<template>
  <div id="user-edit-role">
  <b-modal
      title="分配角色"
      ref="myModalRef"
      ok-title="保存"
      @ok="handleOk"
      @cancel="clearName"
      cancel-title="取消"
    >
      <Transfer
        :data="data"
        v-model="value"
        :right-default-checked="currentRoleInUser"
        :titles="['全部角色', '已选角色']"
      />
    </b-modal>
  </div>
</template>

<script>
import {
  Transfer
} from 'element-ui'

export default {
  props: {
    roleList: Array,
    currentRoleInUser: Array
  },
  data: () => ({
    data: [],
    value: []
  }),
  methods: {
    // * 显示model
    showModel() {
      this.$refs.myModalRef.show()
      this.$nextTick(() => {
        this.initData(this.roleList)
      })
    },
    hideModel() {
      this.$refs.myModalRef.hide()
    },
    // * 数据处理
    initData(param) {
      let arr = []
      if (!param.length) return
      param.map(item => {
        arr.push({
          key: item.id,
          label: item.name,
          disabled: false
        })
      })
      this.data = arr
    },
    // * 隐藏model
    hideModal () {
      this.$refs.myModalRef.hide()
    },
    // * 表单提交
    handleOk(e) {
      e.preventDefault()
      const roleIds = this.value.join(',')
      this.$emit('submit', roleIds)
    },
    // * 取消
    clearName() {}
  },
  watch: {
    currentRoleInUser(value) {
      this.value = value
    }
  },
  components: {
    Transfer
  }
}
</script>

<style>
  #user-edit-role .el-checkbox+.el-checkbox {
    margin-left: 0;

  }
  /* #user-edit-role .el-checkbox, .el-checkbox__input {
    display: block;
  } */
  #user-edit-role .el-transfer-panel__item {
    display: block;
  }
</style>
